<div class="container-fluid">
  <form [formGroup]="createPaymentRequestForm">
    <div class="col-md-12">
      <div class="box">
        <div class="box-header with-border">
          <strong> Create Periodic Bill Payment Request</strong>
        </div>
      </div>
      <!-- /.box-header -->
      <div class="box-body">
        <div class="card-body">
          <span class="text-bold blue">Budget Detail</span>
          <hr>
          <div class="row">
            <div class="col-sm-3">
              <div class="form-group">
                <label>Date <span class="required">*</span></label><br>
                <p-calendar name="date"
                            [style]="{'width':'100%'}" [inputStyle]="{'width':'100%'}"
                            [minDate]="minDate"
                            [showIcon]="false"
                            formControlName="requestedDate"
                            [ngClass]="{ 'is-invalid': submitted && f.requestedDate.errors }"
                            required
                >
                </p-calendar>
                <div *ngIf="submitted && f.requestedDate.errors" class="invalid-feedback">
                  <div *ngIf="f.requestedDate.errors.required">Requested date is required.</div>
                </div>
              </div>
            </div>
            <div class="col-sm-3">
              <div class="form-group">
                <label for="expType">Expenditure Type<span class="required">*</span></label>
                <select id="expType"
                        class="form-control"
                        formControlName="expenditureType"
                        [ngClass]="{ 'is-invalid': submitted && f.expenditureType.errors }"
                        name="expType"
                        required>
                  <option *ngFor="let event of (expenditureTypes); let i = index"
                          [ngValue]="(expenditureTypes)[i]"
                  >{{(expenditureTypes)[i].type + ' ( ' + (expenditureTypes)[i].value + ' )'}}</option>
                </select>
                <div *ngIf="submitted && f.expenditureType.errors" class="invalid-feedback">
                  <div *ngIf="f.expenditureType.errors.required">Expenditure Type is Required.</div>
                </div>
              </div>
            </div>
            <div class="col-sm-3">
              <div class="form-group">
                <label for="month">Month<span class="required">*</span></label>
                <select id="month"
                        class="form-control"
                        name="expType"
                        formControlName="month"
                        [ngClass]="{ 'is-invalid': submitted && f.month.errors }"
                        required
                >
                  <option *ngFor="let event of (months); let i = index"
                          [ngValue]="(months)[i]"
                  >{{ (months)[i].months }}</option>
                </select>
                <div *ngIf="submitted && f.month.errors" class="invalid-feedback">
                  <div *ngIf="f.month.errors.required">Month is Required.</div>
                </div>
              </div>
            </div>
            <div class="col-sm-3">
              <div class="form-group">
                <label for="fiscalYear">Fiscal Year<span class="required">*</span></label>
                <select id="fiscalYear"
                        class="form-control"
                        name="fiscalYear"
                        formControlName="fiscalYear"
                        [ngClass]="{ 'is-invalid': submitted && f.fiscalYear.errors }"
                        required
                >
                  <option *ngFor="let event of (fiscalYears); let i = index"
                          [ngValue]="(fiscalYears)[i]"
                  >{{ (fiscalYears)[i].year }}</option>
                </select>
                <div *ngIf="submitted && f.fiscalYear.errors" class="invalid-feedback">
                  <div *ngIf="f.fiscalYear.errors.required">Fiscal Year is Required.</div>
                </div>
              </div>
            </div>
          </div>

          <div class="form-group">
            <label for="subject">Subject<span class="required">*</span></label>
            <input type="text"
                   class="form-control"
                   id="subject"
                   placeholder="Enter Subject"
                   formControlName="subject"
                   [ngClass]="{ 'is-invalid': submitted && f.subject.errors }"
                   required
            >
            <div *ngIf="submitted && f.subject.errors" class="invalid-feedback">
              <div *ngIf="f.subject.errors.required">Subject is Required.</div>
            </div>
          </div>

          <div class="form-group">
            <label for="link">Reference Link</label>
            <input type="text"
                   class="form-control"
                   id="link"
                   placeholder="Enter Link Url as Reference"
                   formControlName="link"
            >
          </div>

          <div class="form-group">
            <label for="expenseDetail">Expense Detail<span class="required">*</span></label>
            <ckeditor [editor]="Editor"
                      [ngClass]="{ 'is-invalid': submitted && f.expenseDetail.errors }"
                      id="expenseDetail"
                      name="expenseDetail"
                      tagName="textarea"
                      [editor]="Editor"
                      placeholder="Enter Description ( Max length 1000 )"
                      formControlName="expenseDetail"></ckeditor>
            <div *ngIf="submitted && f.expenseDetail.errors" class="invalid-feedback">
              <div *ngIf="f.expenseDetail.errors.required">Expense Detail is Required.</div>
            </div>

            <!--          <textarea class="form-control"-->
            <!--                    rows="3"-->
            <!--                    id="detail"-->
            <!--                    formControlName="expenseDetail"-->
            <!--                    [ngClass]="{ 'is-invalid': submitted && f.expenseDetail.errors }"-->
            <!--                    placeholder="Enter Expense Detail (Min: 10 , Max 500 Characters)"-->
            <!--                    required-->
            <!--          >-->
            <!--                 -->
            <!--              </textarea>-->
          </div>

          <span class="text-bold blue">Bill Detail</span>
          <hr>
          <div class="row">
            <div class="col-sm-4">
              <div class="form-group">
                <label for="vendor">Vendor<span class="required">*</span></label>
                <select id="vendor"
                        class="form-control"
                        name="vendor"
                        formControlName="vendor"
                        (ngModelChange)="renderForm($event)"
                        [ngClass]="{ 'is-invalid': submitted && f.vendor.errors }"
                        required
                >
                  <option *ngFor="let event of (vendors); let i = index"
                          [ngValue]="(vendors)[i]"
                  >{{ (vendors)[i].name + ' ( ' + (vendors)[i].accountNumber + ' )' }}</option>
                </select>
                <div *ngIf="submitted && f.vendor.errors" class="invalid-feedback">
                  <div *ngIf="f.vendor.errors.required">Vendor is Required.</div>
                </div>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label>Bill Date<span class="required">*</span></label><br>
                <p-calendar name="date"
                            [style]="{'width':'100%'}" [inputStyle]="{'width':'100%'}"
                            [minDate]="minDate"
                            size="20"
                            [showIcon]="false"
                            formControlName="billingDate"
                            [ngClass]="{ 'is-invalid': submitted && f.billingDate.errors }"
                            required
                >
                  <div *ngIf="submitted && f.billingDate.errors" class="invalid-feedback">
                    <div *ngIf="f.billingDate.errors.required">Billing is Required.</div>
                  </div>
                </p-calendar>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="billAmount">Bill Amount<span class="required">*</span></label>
                <input type="number"
                       class="form-control"
                       id="billAmount"
                       placeholder="Bill Amount"
                       formControlName="billAmount"
                       [ngClass]="{ 'is-invalid': submitted && f.billAmount.errors }"
                       required
                >
                <div *ngIf="submitted && f.billAmount.errors" class="invalid-feedback">
                  <div *ngIf="f.billAmount.errors.required">Bill Amount is Required.</div>
                </div>
                <span *ngIf="createPaymentRequestForm.value.billAmount" style="color: green">
                      {{createPaymentRequestForm.value.billAmount | numberToWords}}
                    </span>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="billNumber">Bill Number<span class="required">*</span></label>
                <input type="text"
                       class="form-control"
                       id="billNumber"
                       placeholder="Bill Number"
                       formControlName="billNumber"
                       [ngClass]="{ 'is-invalid': submitted && f.billNumber.errors }"
                       required
                >
                <div *ngIf="submitted && f.billNumber.errors" class="invalid-feedback">
                  <div *ngIf="f.billNumber.errors.required">Bill Number Required.</div>
                </div>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="advanceTaken">Advance Taken</label>
                <input type="number"
                       class="form-control"
                       id="advanceTaken"
                       placeholder="Advance Taken"
                       formControlName="advance"
                >
                <span *ngIf="createPaymentRequestForm.value.advance" style="color: green">
                      {{createPaymentRequestForm.value.advance | numberToWords}}
                    </span>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="regType">Registration Type<span class="required">*</span></label>
                <select id="regType"
                        class="form-control"
                        formControlName="registrationType"
                        [ngClass]="{ 'is-invalid': submitted && f.registrationType.errors }"
                        name="expType"
                        required
                >
                  <option *ngFor="let event of (registrationTypes); let i = index"
                          [ngValue]="(registrationTypes)[i]"
                  >{{ (registrationTypes)[i] }}</option>
                </select>
                <div *ngIf="submitted && f.registrationType.errors" class="invalid-feedback">
                  <div *ngIf="f.registrationType.errors.required">Registration Type is Required.</div>
                </div>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="regNumber">Reg. Number</label>
                <input type="text"
                       class="form-control"
                       id="regNumber"
                       placeholder="Reg. Number"
                       formControlName="registrationNumber"
                >
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="vendorAccountNumber">Vendor A/C Number</label>
                <input type="text"
                       class="form-control"
                       id="vendorAccountNumber"
                       placeholder="Vendor Account Number"
                       formControlName="vendorAccountNumber"
                >
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="penaltyAmount">Penalty Amount</label>
                <input type="number"
                       class="form-control"
                       id="penaltyAmount"
                       name="penaltyAmount"
                       placeholder="TDS Amount"
                       formControlName="penaltyAmount"
                >
                <span *ngIf="createPaymentRequestForm.value.penaltyAmount" style="color: green">
                      {{createPaymentRequestForm.value.penaltyAmount | numberToWords}}
              </span>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="rebateAmount">Rebate Amount</label>
                <input type="number"
                       class="form-control"
                       id="rebateAmount"
                       placeholder="TDS Amount"
                       formControlName="rebateAmount"
                >
                <span *ngIf="createPaymentRequestForm.value.rebateAmount" style="color: green">
                      {{createPaymentRequestForm.value.rebateAmount | numberToWords}}
                    </span>
              </div>
            </div>
            <div class="col-sm-2">
              <div class="form-group">
                <label for="customFile">Choose file<span class="required">*</span></label>
                <input type="file"
                       formControlName="file"
                       [ngClass]="{ 'is-invalid': submitted && f.billNumber.errors }"
                       class="form-control"
                       id="customFile"
                       multiple
                       (change)="onFileChange($event)"
                       required
                >
                <div *ngIf="submitted && f.file.errors" class="invalid-feedback">
                  <div *ngIf="f.file.errors.required">File is Required.</div>
                </div>
<!--                <span style="color: red" *ngIf="showFileValidationMessage">Unsupported file format.</span>-->
              </div>
            </div>
          </div>
        </div>


        <div class="card-body">
          <div class="row">
            <div class="col-sm-6">
              <div class="form-group">
                <label for="supporter">Select Supporter</label><br>
                <p-autoComplete formControlName="supporters"
                                id="supporter"
                                class="ui-fluid"
                                [inputStyle]="{'width':'180px'}"
                                [suggestions]="supporter"
                                (completeMethod)="searchSupporter($event)"
                                [minLength]="5"
                                field="fullName"
                                [scrollHeight]="200"
                                placeholder="Select supporter's name"
                                [multiple]="true">
                  <ng-template let-value pTemplate="selectedItem">
                    <span style="font-size:18px">{{value.fullName + '( ' + value.designation + ') '}}</span>
                  </ng-template>
                </p-autoComplete>
              </div>
            </div>
            <div class="col-sm-6">
              <div class="form-group">
                <label for="approver">Select Approver<span class="required">*</span></label><br>
                <p-autoComplete formControlName="approvers"
                                [ngClass]="{ 'is-invalid': submitted && f.approvers.errors }"
                                id="approver"
                                class="ui-fluid"
                                [inputStyle]="{'width':'180px'}"
                                [suggestions]="approver"
                                (completeMethod)="searchApprover($event)"
                                [minLength]="5"
                                field="fullName"
                                [scrollHeight]="200"
                                placeholder="Select approver's name"
                                [multiple]="true">
                  <ng-template let-value pTemplate="selectedItem">
                    <span style="font-size:18px">{{value.fullName + '( ' + value.designation + ') '}}</span>
                  </ng-template>
                </p-autoComplete>
                <div *ngIf="submitted && f.approvers.errors" class="invalid-feedback">
                  <div *ngIf="f.approvers.errors.required">Approver is Required.</div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="card-footer">
          <div class="row">
            <div class="col-sm-6">
              <button class="btn btn-success btn-block"
                      type="submit"
                      (click)="confirmCreateRequest()">
                Submit
              </button>
            </div>
            <div class="col-sm-6">
              <button class="btn btn-danger btn-block" (click)="goTo()">Cancel</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </form>
</div>


<p-dialog [(visible)]="showConfirmationPage"
          [modal]="true" [responsive]="true" [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    <h4 style="font-weight: 800;color: #454545;float: left; margin: 0;">Confirm, Periodic Payment Detail.. </h4>
  </p-header>

  <div class="row">
    <div class="col-md-12 mt-3">
      <strong>Budget Detail</strong>
      <hr>
      <div class="col-md-6 form-group float-left">
        <label>Requested Date :</label>
        <p>{{ createPaymentRequestForm.value.requestedDate | date: 'short' }}</p>
      </div>
      <div class="col-md-6 form-group float-left" *ngIf="createPaymentRequestForm.value.expenditureType">
        <label>Expenditure Type :</label>
        <p>{{ createPaymentRequestForm.value.expenditureType.type }}</p>
      </div>
      <div class="col-md-6 form-group float-left" *ngIf="createPaymentRequestForm.value.month">
        <label>Months :</label>
        <p>{{ createPaymentRequestForm.value.month.months }}</p>
      </div>

      <div class="col-md-6 form-group float-left" *ngIf="createPaymentRequestForm.value.fiscalYear">
        <label>Fiscal Year :</label>
        <p>{{ createPaymentRequestForm.value.fiscalYear.year }}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Subject:</label>
        <p>{{createPaymentRequestForm.value.subject}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Expense Detail :</label>
        <p>{{createPaymentRequestForm.value.expenseDetail}}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3">
      <strong>Bill Detail </strong>
      <hr>
      <div class="col-md-6 form-group float-left" *ngIf="createPaymentRequestForm.value.vendor">
        <label>Vendor Name :</label>
        <p>{{ createPaymentRequestForm.value.vendor.name }}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Bill Date :</label>
        <p>{{ createPaymentRequestForm.value.billingDate | date: 'short' }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Bill Number :</label>
        <p>{{ createPaymentRequestForm.value.billNumber }}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Bill Amount :</label>
        <p>{{createPaymentRequestForm.value.billAmount}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Advance Taken:</label>
        <p>{{createPaymentRequestForm.value.advance}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Reg. Type :</label>
        <p>{{createPaymentRequestForm.value.registrationType}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Reg. Number :</label>
        <p>{{ createPaymentRequestForm.value.registrationNumber }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>TDS Amount:</label>
        <p>{{createPaymentRequestForm.value.tdsAmount }}</p>
      </div>
      <div class="col-md-6 form-group float-left">
        <label>Acc. Number :</label>
        <p>{{ createPaymentRequestForm.value.vendorAccountNumber }}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3">
      <div class="col-md-6 form-group float-left">
        <label>Approved By:</label>
        <p *ngFor="let approvers of createPaymentRequestForm.value.approvers">
          {{approvers.fullName + ' ( ' + approvers.designation + ' )'}}</p>
      </div>
    </div>
    <div class="col-md-12 mt-3">
      <div class="col-md-6 form-group float-left">
        <label>Supported By:</label>
        <p *ngFor="let supporters of createPaymentRequestForm.value.supporters">
          {{supporters.fullName + ' ( ' + supporters.designation + ' )'}}</p>
      </div>
    </div>
  </div>
  <footer>
    <div class="row">
      <div class="col-md-12">
        <div class="col-md-12 mb-3">
          <button class="btn btn-sm btn-success float-right"
                  type="submit"
                  [disabled]="loading"
                  (click)="onSubmit()">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Confirm
          </button>
          <button class="btn btn-sm btn-danger btn-outline- ml-3 float-right"
                  type="button"
                  [disabled]="loading"
                  (click)="showConfirmationPage=false">
            Cancel
          </button>
        </div>
      </div>
    </div>
  </footer>
</p-dialog>
